/*
    toppers_arm_arch_interface.c
    Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
              Graduate School of Information Science, Nagoya Univ., JAPAN

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* toppers_add at  2007-08-28, read and write by COM */
extern ARMword toppers_devm_read_byte (ARMul_State * state, ARMword addr);
extern void toppers_devm_write_byte (ARMul_State * state, ARMword addr,
			      ARMword data);
extern ARMword toppers_devm_read_halfword (ARMul_State * state, ARMword addr);
extern void toppers_devm_write_halfword (ARMul_State * state, ARMword addr,
				  ARMword data);
extern ARMword toppers_devm_read_word (ARMul_State * state, ARMword addr);
extern void toppers_devm_write_word (ARMul_State * state, ARMword addr,
			      ARMword data);
extern void toppers_set_devm_address (unsigned long address, unsigned long size,
			      unsigned long devm_address);

/* toppers_add at  2007-09-19, read and write by shared memory */
extern ARMword toppers_shmem_read_byte (ARMul_State * state, ARMword addr);
extern void toppers_shmem_write_byte (ARMul_State * state, ARMword addr,
			      ARMword data);
extern ARMword toppers_shmem_read_halfword (ARMul_State * state, ARMword addr);
extern void toppers_shmem_write_halfword (ARMul_State * state, ARMword addr,
				  ARMword data);
extern ARMword toppers_shmem_read_word (ARMul_State * state, ARMword addr);
extern void toppers_shmem_write_word (ARMul_State * state, ARMword addr,
			      ARMword data);
extern void toppers_create_shared_memory (unsigned long address, unsigned long size,
			      unsigned long devm_address, void * mem);


/*--------------------------------------------------------------------------*/

#define  	TOPPERS_ARM_PARSE_MEM1                            \
    /*                                                        \
	 *  toppers_add at  2007-08-28                            \
	 *  skyeye.confmem_bank map=D̂Ƃ(foCX}l[W  \
	 *                                    Ƃ̒ʐMp)         \
	 */                                                       \
	else if (!strncmp ("D", value, strlen (value))) {         \
		mb[num].read_byte = toppers_devm_read_byte;           \
		mb[num].write_byte = toppers_devm_write_byte;         \
		mb[num].read_halfword = toppers_devm_read_halfword;   \
		mb[num].write_halfword = toppers_devm_write_halfword; \
		mb[num].read_word = toppers_devm_read_word;           \
		mb[num].write_word = toppers_devm_write_word;         \
		mb[num].type = TOPPERS_MEMTYPE_DEVM;                  \
	}                                                         \
	/*                                                        \
	 * toppers_add at 2007-09-19                              \
	 * skyeye.confmem_bank map=ŜƂ(L)          \
	 */                                                       \
	else if (!strncmp ("S", value, strlen (value))) {         \
		mb[num].read_byte = toppers_shmem_read_byte;          \
		mb[num].write_byte = toppers_shmem_write_byte;        \
		mb[num].read_halfword = toppers_shmem_read_halfword;  \
		mb[num].write_halfword = toppers_shmem_write_halfword;\
		mb[num].read_word = toppers_shmem_read_word;          \
		mb[num].write_word = toppers_shmem_write_word;        \
		mb[num].type = TOPPERS_MEMTYPE_SHMEM;                 \
	}                                                         \

#define 	TOPPERS_ARM_PARSE_MEM2                                                        \
    /* toppers_add at 2007-08-28 */                                                       \
    if (mb[num].type == TOPPERS_MEMTYPE_DEVM) {                                           \
                if (!devm_addr_set)                                                       \
                        devm_addr = mb[num].addr;                                         \
                toppers_set_devm_address (mb[num].addr, mb[num].len, devm_addr);          \
        }                                                                                 \
    /* toppers_add at 2007-09-19 */                                                       \
        else if (mb[num].type == TOPPERS_MEMTYPE_SHMEM) {                                 \
                if (!devm_addr_set)                                                       \
                        devm_addr = mb[num].addr;                                         \
                toppers_create_shared_memory (mb[num].addr, mb[num].len, devm_addr, NULL);\
        }                                                                                 \	
    /* toppers_add at 2007-09-19 */                                                       \
        if (mb[num].len == 0) {                                                           \
                /** armmem.cbank_ptr֐ŁAlen0Ƃ͂ **/                    \
                SKYEYE_ERR ("Error: mem_bank[%d] size must not be 0.\n", num);            \
                SKYEYE_ERR ("       mem_bank[%d] address = 0x%08x\n", num, mb[num].addr) ;\
                return 0;                                                                 \
        }                                                                                 \
    /*                                                                                    \
     * toppers_add at 2007-09-19                                                          \
     * ̃I[obv`FbN                                                 \
     */                                                                                   \
        for (i = 0; i < num; i++) {                                                       \
                if (!(mb[num].addr + mb[num].len <= mb[i].addr                            \
                          || mb[i].addr + mb[i].len <= mb[num].addr)) {                   \
                        SKYEYE_ERR ("Error: mem_bank address spaces are overlapped.\n");  \
                        SKYEYE_ERR ("       mem_bank[%d] address=0x%08x size=0x%08x.\n",  \
                                i, mb[i].addr, mb[i].len);                                \
                        SKYEYE_ERR ("       mem_bank[%d] address=0x%08x size=0x%08x.\n",  \
                                num, mb[num].addr, mb[num].len);                          \
                        return 0;                                                         \
                }                                                                         \
    }                          


